VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmGeoMetric 
   Caption         =   "Geometric Information"
   ClientHeight    =   7455
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4770
   OleObjectBlob   =   "frmGeoMetric.frx":0000
   ShowModal       =   0   'False
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "frmGeoMetric"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit
Private Declare Function CountArea Lib "CountArea" Alias "#1" (ByVal Name As String) As Long

Private CurUnit As Long
Private Lang As New clsLang
Private bPerimeter As Boolean
Private bValidSelection As Boolean
Private bValidArea As Boolean
Private vDepth As Double

Private vLength As Double
Private vArea As Double

Dim iShapeCnt As Integer

Private WithEvents cPrecision As clsIntSpin
Attribute cPrecision.VB_VarHelpID = -1

Private Sub OnUnitChange(ByVal Unit As Long)
    Dim strLength As String
    Dim strArea As String
    Dim strVolume As String

    vDepth = Application.ConvertUnits(vDepth, GetAppUnits(CurUnit), GetAppUnits(Unit))
    CurUnit = Unit
    UpdateDepth

    strLength = GetCurUnitString()
    lblUnitLength.Caption = strLength
    lblUnitArea.Caption = strLength & GetSquare(False)
    lblUnitDepth.Caption = strLength
    lblUnitVolume.Caption = strLength & GetCube(False)

    'UpdateValues
    RefreshForm
End Sub

Private Sub UpdateDepth()
    Updating = Updating + 1
    txtDepth.Text = CStr(vDepth)
    Updating = Updating - 1
End Sub

Private Function GetCurUnitString() As String
    Dim strLength As String
    Select Case CurUnit
        Case 0
            strLength = Lang.GetString(eUnitInch)
        Case 1
            strLength = Lang.GetString(eUnitMM)
        Case 2
            strLength = Lang.GetString(eUnitPicaPoint)
        Case 3
            strLength = Lang.GetString(eUnitPoint)
        Case 4
            strLength = Lang.GetString(eUnitPixel)
        Case 5
            strLength = Lang.GetString(eUnitCiceroDidot)
        Case 6
            strLength = Lang.GetString(eUnitDidot)
        Case 7
            strLength = Lang.GetString(eUnitFoot)
        Case 8
            strLength = Lang.GetString(eUnitYard)
        Case 9
            strLength = Lang.GetString(eUnitMile)
        Case 10
            strLength = Lang.GetString(eUnitCM)
        Case 11
            strLength = Lang.GetString(eUnitM)
        Case 12
            strLength = Lang.GetString(eUnitKM)

    End Select
    GetCurUnitString = strLength
End Function

Private Function GetSquare(ByVal bUnicode As Boolean) As String
    Dim s As String
    s = ChrW$(178)
    If Not bUnicode And Asc(s) = 63 Then
        s = "2"
    End If
    GetSquare = s
End Function

Private Function GetCube(ByVal bUnicode As Boolean) As String
    Dim s As String
    s = ChrW$(179)
    If Not bUnicode And Asc(s) = 63 Then
        s = "3"
    End If
    GetCube = s
End Function

Private Sub cArea_Click()
    UpdateControls
End Sub

Private Sub cboUnits_Change()
    OnUnitChange cboUnits.ListIndex
End Sub

Private Sub cLength_Click()
    UpdateControls
End Sub

Private Sub cmClose_Click()
    Unload Me
End Sub

Private Sub cmCopy_Click()
    Dim sData As String
    Dim oData As New DataObject

    sData = GetDataString(False)
    If sData <> "" Then
        oData.SetText sData
        oData.PutInClipboard
    End If
End Sub

Private Sub cmCreateText_Click()
    Const TextSize As Double = 24 ' 24 pt text
    Dim lr As Layer
    Dim sData As String
    Dim sr As ShapeRange
    Dim x As Double, y As Double, w As Double, h As Double
    sData = GetDataString(True)
    Updating = Updating + 1
    If Not ActiveShape Is Nothing And sData <> "" Then
        Set sr = ActiveSelectionRange
        ActiveShape.GetBoundingBox x, y, w, h
        x = x + w / 2
        y = y - ActiveDocument.ToUnits(TextSize, cdrPoint)
        Set lr = ActiveShape.Layer
        If lr.Editable Then Set lr = ActiveLayer
        lr.CreateArtisticText x, y, sData, cdrEnglishUS, , "Arial", 24, cdrTrue, cdrTrue, , cdrCenterAlignment
        sr.CreateSelection
    End If
    Updating = Updating - 1
End Sub

Private Sub cmRefresh_Click()
    RefreshForm
End Sub

Private Sub cmReset_Click()
    vDepth = 0
    UpdateDepth
    UpdateValues
End Sub

Private Sub cPrecision_Change()
    UpdateValues
End Sub

Private Sub cVolume_Click()
    UpdateControls
End Sub

Private Sub grpLength_Click()

End Sub

Private Sub lblSelShapeCnt_Click()

End Sub

Private Sub txtDepth_Change()
    Dim s As String
    
    If Updating Then Exit Sub
    
    s = Trim$(txtDepth.Text)
    If s <> "" Then
        vDepth = Val(Replace(s, ",", "."))
    Else
        vDepth = 0
    End If
    UpdateValues
End Sub

Private Sub UserForm_Initialize()
On Error GoTo ErrHndlr
    Updating = 0
    vDepth = 0
    
    Set cPrecision = New clsIntSpin
    cPrecision.Init txtPrecision, spnPrecision, 3, lblPrecision, 0, 5, 1
    
    Me.Caption = Lang.GetString(eFormCaption)
    cShapeSelCnt.Caption = Lang.GetString(eCapShapeSelCnt)
    
    grpLength.Caption = Lang.GetString(eCapPerimeter)
    cLength.Caption = Lang.GetString(eCapPerimeter) & ":"
    bPerimeter = True
    
    grpArea.Caption = Lang.GetString(eCapArea)
    cArea.Caption = Lang.GetString(eCapArea) & ":"
    
    grpVolume.Caption = Lang.GetString(eCapVolume)
    lblDepth.Caption = Lang.GetString(eCapDepth) & ":"
    cmReset.Caption = Lang.GetString(eBtnReset)
    cVolume.Caption = Lang.GetString(eCapVolume) & ":"
    
    cmCreateText.Caption = Lang.GetString(eBtnCreateText)
    cmCopy.Caption = Lang.GetString(eBtnCopy)
    cmClose.Caption = Lang.GetString(eBtnClose)
    cmRefresh.Caption = Lang.GetString(eBtnRefresh)
    lblUnits.Caption = Lang.GetString(eCapUnits) & ":"
    lblPrecision.Caption = Lang.GetString(eCapPrecision) & ":"
   
    cboUnits.Clear
    cboUnits.AddItem Lang.GetString(eStrInch)
    cboUnits.AddItem Lang.GetString(eStrMM)
    cboUnits.AddItem Lang.GetString(eStrPicaPoint)
    cboUnits.AddItem Lang.GetString(eStrPoint)
    cboUnits.AddItem Lang.GetString(eStrPixel)
    cboUnits.AddItem Lang.GetString(eStrCiceroDidot)
    cboUnits.AddItem Lang.GetString(eStrDidot)
    cboUnits.AddItem Lang.GetString(eStrFoot)
    cboUnits.AddItem Lang.GetString(eStrYard)
    cboUnits.AddItem Lang.GetString(eStrMile)
    cboUnits.AddItem Lang.GetString(eStrCM)
    cboUnits.AddItem Lang.GetString(estrm)
    cboUnits.AddItem Lang.GetString(eStrKM)
    
    cboUnits.ListIndex = IIf(Lang.IsMetric(), 1, 0)
    
    'Set the value of the cboUnits control to that of the horiztontal document ruler
    Select Case ActiveDocument.Rulers.HUnits
    
        Case 1 'Inch
            cboUnits.ListIndex = 0
        Case 2 'Foot
            cboUnits.ListIndex = 7
        Case 3 'Millimeter
           cboUnits.ListIndex = 1
        Case 4 'Centimeter
            cboUnits.ListIndex = 10
        Case 5 'Pixel
            cboUnits.ListIndex = 4
        Case 6 'Mile
            cboUnits.ListIndex = 9
        Case 7 'Meter
            cboUnits.ListIndex = 11
        Case 8 'Kilometer
            cboUnits.ListIndex = 12
        Case 9 'Didot
            cboUnits.ListIndex = 6
        Case 10 'Agate
            cboUnits.ListIndex = 1
        Case 11 'Yard
            cboUnits.ListIndex = 8
        Case 12 'Pica
            cboUnits.ListIndex = 2
        Case 13 'Cicero
            cboUnits.ListIndex = 5
        Case 14 'Point
            cboUnits.ListIndex = 3
    End Select
    
    RefreshForm
    MacroRunning = True
Exit Sub
ErrHndlr:
If Err.Number = 91 Then Resume Next 'For if a page is not created and the ruler does not exist.
End Sub

Sub RefreshForm()
    Dim sShape As Shape
    
    bValidSelection = False
    bValidArea = False
    
    Updating = Updating + 1
    
    On Error GoTo ErrHandler
    
    If Not ActiveDocument Is Nothing Then
        txtLength.Text = 0
        txtArea.Text = 0
        txtVolume.Text = 0
        txtStatusBar.Text = ""
        lblSelShapeCnt.Caption = 0
        iShapeCnt = 0
        vLength = 0
        For Each sShape In ActiveDocument.Selection.Shapes
            GetShapeInformation sShape
        Next
    End If
ExitSub:
    UpdateControls
    Updating = Updating - 1
    Exit Sub
    
ErrHandler:
    ShowStatusMessage Lang.GetString(eStrError) & ": " & Err.Description
    Resume ExitSub
End Sub
Private Sub GetShapeInformation(sShape As Shape)
    Dim nSelCount As Long
    Dim dPermiter As Double
    Dim dArea As Double
    Dim dVolume As Double
    Dim s As Shape
      
    If sShape.Type = cdrGroupShape Or sShape.Type = cdrExtrudeGroupShape Then
        For Each s In sShape.Shapes
            GetShapeInformation s
        Next s
    Else
        dPermiter = txtLength.Text
        dArea = txtArea.Text
        dVolume = txtVolume.Text
        ProcessSelection sShape
        txtArea.Text = txtArea.Text + dArea
        txtLength.Text = txtLength.Text + dPermiter
        txtVolume.Text = txtVolume.Text + dVolume
        iShapeCnt = iShapeCnt + 1
    End If
        
    lblSelShapeCnt.Caption = iShapeCnt
End Sub

Private Sub EnableTextControl(ByVal Txt As TextBox, ByVal bState As Boolean)
    Txt.Enabled = bState
    Txt.BackColor = IIf(bState, vbWindowBackground, vbButtonFace)
End Sub

Private Sub UpdateControls()
    Dim bEnabled As Boolean
    
    cLength.Enabled = bValidSelection
    EnableTextControl txtLength, bValidSelection
    lblUnitLength.Enabled = bValidSelection

    cArea.Enabled = bValidArea
    EnableTextControl txtArea, bValidArea
    lblUnitArea.Enabled = bValidArea
    
    lblDepth.Enabled = bValidArea
    EnableTextControl txtDepth, bValidArea
    lblUnitDepth.Enabled = bValidArea
    cmReset.Enabled = bValidArea
    cVolume.Enabled = bValidArea
    EnableTextControl txtVolume, bValidArea
    lblUnitVolume.Enabled = bValidArea
    
    bEnabled = bValidSelection
    If bEnabled Then
        bEnabled = cLength.Value <> 0
        If bValidArea And Not bEnabled Then
            bEnabled = cArea.Value <> 0 Or cVolume.Value <> 0
        End If
    End If
    cmCreateText.Enabled = bEnabled
    cmCopy.Enabled = bEnabled
End Sub

Private Sub ProcessSelection(ByVal s As Shape)
    If s.Type = cdrGroupShape Then
        ShowStatusMessage Lang.GetString(eStrGroupSelected)
    ElseIf s.IsSimpleShape And s.Type <> cdrTextShape Then
        ProcessCurve s.DisplayCurve
    Else
        ShowStatusMessage Lang.GetString(eStrInvalidObject)
    End If
End Sub

Private Function CheckSubpaths(ByVal crv As Curve) As Boolean
    Dim bRet As Boolean
    Dim n As Long
    bRet = True
    If crv.SubPaths.Count <> 1 Then
        For n = 2 To crv.SubPaths.Count
            If crv.SubPaths(n).Nodes.Count > 1 Then
                bRet = False
                Exit For
            End If
        Next n
    End If
    CheckSubpaths = bRet
End Function

Private Sub ProcessCurve(ByVal crv As Curve)
    Dim v As Double
    Dim bClearStatus As Boolean
    Dim bClosed As Boolean
    
    bClosed = crv.SubPaths(1).Closed
    bClearStatus = True
    bValidArea = bClosed ' And CheckSubpaths(crv)
    If bValidArea Then
        grpLength.Caption = Lang.GetString(eCapPerimeter)
        cLength.Caption = Lang.GetString(eCapPerimeter) & ":"
        bPerimeter = True
    Else
        grpLength.Caption = Lang.GetString(eCapLength)
        cLength.Caption = Lang.GetString(eCapLength) & ":"
        bPerimeter = False
    End If
    
    bValidSelection = True
    vLength = crv.Length
    
    If bValidArea Then
        vArea = CountArea(StrPtr(""))  'calcShapeArea(crv.SubPaths(1))
    Else
'
        If bClosed Then
            ShowStatusMessage Lang.GetString(eStrMultipathCurve)
 
        Else
            vArea = 0
            ShowStatusMessage Lang.GetString(eStrCurveOpen)
        End If
        bClearStatus = False
    End If
    
    If bClearStatus Then ClearStatusMessage
    UpdateValues
End Sub

Private Sub UpdateValues()
    Dim v As Double
    txtLength.Text = FormatValue(GetLength(vLength))
    
    If bValidArea Then
        v = GetArea(vArea)
        txtArea.Text = FormatValue(v)
        txtVolume.Text = FormatValue(v * vDepth)
    Else
        txtArea.Text = 0
        txtVolume.Text = 0
    End If
End Sub

Private Function FormatValue(ByVal v As Double) As String
    Dim sFormat As String
    sFormat = "0"
    If cPrecision.GetValue() > 0 Then
        sFormat = "0." & String$(cPrecision.GetValue(), "0")
    End If
    FormatValue = Format$(v, sFormat)
End Function

Private Function GetAppUnits(ByVal vUnit As Long) As cdrUnit
    Dim tUnit As cdrUnit
    Select Case vUnit
        Case 0
            tUnit = cdrInch
        Case 1
            tUnit = cdrMillimeter
        Case 2
            tUnit = cdrPica
        Case 3
            tUnit = cdrPoint
        Case 4
            tUnit = cdrPixel
        Case 5
            tUnit = cdrCicero
        Case 6
            tUnit = cdrDidots
        Case 7
            tUnit = cdrFoot
        Case 8
            tUnit = cdrYard
        Case 9
            tUnit = cdrMile
        Case 10
            tUnit = cdrCentimeter
        Case 11
            tUnit = cdrMeter
        Case 12
            tUnit = cdrKilometer
    End Select
    GetAppUnits = tUnit
End Function

Private Function GetLength(ByVal v As Double) As Double
    If ActiveDocument Is Nothing Then
        GetLength = 0
    Else
        GetLength = ActiveDocument.FromUnits(v, GetAppUnits(CurUnit)) * ActiveDocument.WorldScale
    End If
End Function

Private Function GetArea(ByVal v As Double) As Double
    GetArea = GetLength(GetLength(v))
End Function

Private Function calcShapeArea(ByVal sp As SubPath) As Double
    Dim cx As New Collection
    Dim cy As New Collection
    Dim seg As Segment
    Dim n As Long
    Dim x As Double, y As Double
    Dim Area As Double
    Dim nPts As Long
    
    sp.StartNode.GetPosition x, y
    
    cx.Add x
    cy.Add y
    
    For Each seg In sp.Segments
        If seg.Type = cdrCurveSegment Then
            For n = 1 To 49
                seg.GetPointPositionAt x, y, n / 50
                cx.Add x
                cy.Add y
            Next n
        End If
        seg.EndNode.GetPosition x, y
        cx.Add x
        cy.Add y
    Next seg
    
    Area = 0
    For n = 1 To cx.Count - 1
        Area = Area + cx(n) * cy(n + 1) - cy(n) * cx(n + 1)
    Next
    
    calcShapeArea = Abs(Area / 2)
End Function

Private Sub ShowStatusMessage(ByVal msg As String)
    'txtStatusBar.Text = msg
    If msg <> "" Then
        txtStatusBar.Text = txtStatusBar.Text + "- " + msg + Chr(13)
    End If
End Sub

Private Sub ClearStatusMessage()
'    txtStatusBar.Text = ""
End Sub

Private Sub UserForm_Terminate()
    MacroRunning = False
End Sub

Private Function GetDataString(ByVal bUnicode As Boolean)
    Dim s As String
    s = ""
    If bValidSelection Then
        If cLength.Value Then
            If bPerimeter Then
                s = Lang.GetString(eCapPerimeter)
            Else
                s = Lang.GetString(eCapLength)
            End If
            s = s & " = " & txtLength.Text & " " & GetCurUnitString()
        End If
        
        If bValidArea Then
            If cArea.Value Then
                If s <> "" Then s = s & vbCrLf
                s = s & Lang.GetString(eCapArea) & " = " & txtArea.Text & " " & GetCurUnitString() & GetSquare(bUnicode)
            End If
            
            If cVolume.Value Then
                If s <> "" Then s = s & vbCrLf
                s = s & Lang.GetString(eCapVolume) & " = " & txtVolume.Text & " " & GetCurUnitString() & GetCube(bUnicode)
            End If
        End If
    End If
    GetDataString = s
End Function


